datablock AudioProfile(SmokeGrenadeExplosionSound)
{
   filename    = "./smoke_splode.wav";
   description = AudioDefault3d;
   preload = false;
};

datablock AudioProfile(SmokeGrenadeBounceSound)
{
   filename    = "./smoke_bounce.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(SmokeGrenadeExplosionParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 12000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 5.0;
	spinRandomMin		= -5.0;
	spinRandomMax		= 5.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "1 1 1 0.4";
	colors[1]	= "0.8 0.8 0.8 0.6";
   colors[2]	= "0.8 0.8 0.8 0.0";

	sizes[0]	= 2.0;
	sizes[1]	= 11.0;
   sizes[2]	= 10.5;

	times[0]	= 0.0;
	times[1]	= 0.01;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(SmokeGrenadeExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 10;
   velocityVariance = 5.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 90;
   overrideAdvance = false;
   particles = "SmokeGrenadeExplosionParticle";
};

datablock ParticleData(SmokeGrenadeExplosionParticle2)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 9000;
	lifetimeVarianceMS	= 3990;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.8 0.8 0.8 0.4";
	colors[1]	= "0.8 0.8 0.8 0.3";
   colors[2]	= "0.8 0.8 0.8 0.0";

	sizes[0]	= 12.0;
	sizes[1]	= 25.0;
   sizes[2]	= 27.0;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(SmokeGrenadeExplosionEmitter2)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   lifetimeMS       = 120;
   ejectionVelocity = 15;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SmokeGrenadeExplosionParticle2";
};

datablock ExplosionData(SmokeGrenadeExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   soundProfile = SmokeGrenadeExplosionSound;
   
   emitter[0] = SmokeGrenadeExplosionEmitter2;
   //emitter[1] = "";
   //emitter[2] = "";
   //emitter[0] = "";

   particleEmitter = SmokeGrenadeExplosionEmitter;
   particleDensity = 40;
//   particleDensity = 0;
   particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 3;
   impulseForce = 4000;

	uiName = "Smoke Grenade Fog";
};

//projectile
datablock ProjectileData(SmokeGrenadeProjectile)
{
   projectileShapeName = "./SMOKEGRENADE5.dts";
   directDamage        = 0;
   directDamageType  = $DamageType::RocketDirect;
   radiusDamageType  = $DamageType::RocketRadius;
   impactImpulse	   = 200;
   verticalImpulse	   = 200;
   explosion           = SmokeGrenadeExplosion;
   //particleEmitter     = SmokeGrenadeTrailEmitter;

   muzzleVelocity      = 50;
   velInheritFactor    = 0;
   explodeOnDeath = true;

   armingDelay         = 2500; 
   lifetime            = 2500;
   fadeDelay           = 3000;
   bounceElasticity    = 0.7;
   bounceFriction      = 0.3;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Smoke Grenade";
};


//////////
// item //
//////////
datablock ItemData(SmokeGrenadeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./SMOKEGRENADE5.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Smoke Grenade";
	iconName = "./ci_SMOKEGRENADE";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = SmokeGrenadeImage;
	canDrop = true;
};

datablock ShapeBaseImageData(SmokeGrenadeImage)
{
   // Basic Item properties
   shapeFile = "./SMOKEGRENADE5.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SmokeGrenadeItem;
   ammo = " ";
   projectile = SmokeGrenadeProjectile;
   projectileType = Projectile;

   	casing = SmokeGrenadePinDebris;
	shellExitDir        = "-2.0 1.0 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;

	stateName[2]			= "SKIPPED";
	stateTransitionOnTimeout[2]	= "SKIPPED2";
	stateAllowImageChange[2]	= false;
	stateTimeoutValue[2]		= 0.2;
	stateSound[2]				= SmokeGrenadeFireSound;
	stateSequence[2]                = "SKIPPED";
	stateEjectShell[2]       = true;

	stateName[3]			= "SKIPPED2";
	stateTransitionOnTriggerDown[3]	= "Charge";
	stateAllowImageChange[3]	= false;
	
	stateName[4]                    = "Charge";
	stateTransitionOnTimeout[4]	= "Armed";
	stateTimeoutValue[4]            = 0.7;
	stateWaitForTimeout[4]		= false;
	stateTransitionOnTriggerUp[4]	= "AbortCharge";
	stateScript[4]                  = "onCharge";
	stateAllowImageChange[4]        = false;
	
	stateName[5]			= "AbortCharge";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.3;
	stateWaitForTimeout[5]		= true;
	stateScript[5]			= "onAbortCharge";
	stateAllowImageChange[5]	= false;

	stateName[6]			= "Armed";
	stateTransitionOnTriggerUp[6]	= "Fire";
	stateAllowImageChange[6]	= false;

	stateName[7]			= "Fire";
	stateTransitionOnTimeout[7]	= "Done";
	stateTimeoutValue[7]		= 0.5;
	stateFire[7]			= true;
	stateSequence[7]		= "fire";
	stateScript[7]			= "onFire";
	stateWaitForTimeout[7]		= true;
	stateAllowImageChange[7]	= false;

	stateName[8]					= "Done";
	stateScript[8]					= "onDone";

};

package SmokeGrenadePackage
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "SmokeGrenadeItem" && %col.canPickup)
		{
			for(%i=0;%i<%this.maxTools;%i++)
			{
				%item = %obj.tool[%i];
				if(%item $= 0 || %item $= "")
				{
					%freeSlot = 1;
					break;
				}
			}

			if(%freeSlot)
			{
				%obj.pickup(%col);
				return;
			}
		}
		Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}
};
activatePackage(SmokeGrenadePackage);

function SmokeGrenadeImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
	%obj.lastHESlot = %obj.currTool;
}

function SmokeGrenadeImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function SmokeGrenadeProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	serverPlay3D(SmokeGrenadeBounceSound,%obj.getTransform());
}

function SmokeGrenadeImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::OnFire(%this, %obj, %slot);

	%currSlot = %obj.lastHESlot;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
}

function SmokeGrenadeImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

datablock DecalData(SmokeGrenadeIcon)
{
   textureName = "Add-Ons/Weapon_SmokeGrenade/icon_SmokeGrenade";
};
function SmokeFlash(%pos,%time)
{
	%mask = $TypeMasks::PlayerObjectType;
	%boxsize = "15 15 15";
	%position = %pos;
	initContainerBoxSearch(%position, %boxSize, %mask);
	while(%searchObj = containerSearchNext())
	{
 		if(isObject(%searchObj))
		{
			if(%searchObj.dataBlock $= "Playerblackopscamera")
				return;
			if(%searchObj.client.perk != 3)
			{
				%searchObj.setWhiteOut(0.1);
				//%searchObj.setHealth((100-%searchObj.getDamageLevel())-1);
			}
		}
	}


	%time++;
	if(%time<200)
		schedule(250,0,SmokeFlash,%pos,%time);
}
function SmokeGrenadeProjectile::onExplode(%this,%obj)
{
SmokeFlash(%obj.position,0);
//if(%obj.gen<5)
	//{
	//	%p = new Projectile()
	//	{
	//		datablock = blackopsnovagasprojectile;
	//		initialPosition = %obj.position;
	//		gen = %obj.gen+1;
	//		noclick = true;
	//	};
	//	missioncleanup.add(%p);
	//}
	//
	//%obj.noclick = true;

	parent::onExplode(%this, %obj);
}
